/*
 * COPYRIGHT LICENSE: This information contains sample code provided in source code form.
 * You may copy, modify, and distribute these sample programs in any form without payment
 * to IBM for the purposes of developing, using, marketing or distributing application
 * programs conforming to the application programming interface for the operating platform
 * for which the sample code is written.
 * 
 * Notwithstanding anything to the contrary, IBM PROVIDES THE SAMPLE SOURCE CODE ON 
 * AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
 * BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY,
 * SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR
 * CONDITION OF NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF
 * THE SAMPLE SOURCE CODE. IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
 * 
 * (C) Copyright IBM Corp. 2001, 2013.
 * All Rights Reserved. Licensed Materials - Property of IBM.
 */
package com.ibm.ws.samples.struts1.action;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.actions.MappingDispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.commons.beanutils.PropertyUtils;

import com.ibm.ws.samples.phonebook.PhoneBookEntry;
import com.ibm.ws.samples.phonebook.SimplePhoneBookManager;
import com.ibm.ws.samples.phonebook.SimplePhoneBookManagerImpl;

import com.ibm.ws.samples.struts1.form.PhoneBookForm;
import com.ibm.ws.samples.struts1.form.PhoneBookClientBean;

public class PhoneBookAction extends MappingDispatchAction {

    public ActionForward listPhones(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {

        List<PhoneBookClientBean> myPhoneList = new ArrayList<PhoneBookClientBean>();

        SimplePhoneBookManager myPBMgr = new SimplePhoneBookManagerImpl();
        for (PhoneBookEntry aPhone : myPBMgr.getPhoneBook()) {
            PhoneBookClientBean aPhoneBookClientBean = new PhoneBookClientBean();
            PropertyUtils.copyProperties(aPhoneBookClientBean, aPhone);
            myPhoneList.add(aPhoneBookClientBean);
        }

        PhoneBookForm phoneBookForm = (PhoneBookForm) form;
        phoneBookForm.setPhoneBook(myPhoneList);

        return mapping.findForward("success");
    }

}